(function () {
  try {
    return angular.module('bonitasoft.ui.widgets');
  } catch(e) {
    return angular.module('bonitasoft.ui.widgets', []);
  }
})().directive('customAutoAssignWidget', function() {
    return {
      controllerAs: 'ctrl',
      controller: /**
 * The controller is a JavaScript function that augments the AngularJS scope and exposes functions that can be used in the custom widget template
 * 
 * Custom widget properties defined on the right can be used as variables in a controller with $scope.properties
 * To use AngularJS standard services, you must declare them in the main function arguments.
 * 
 * You can leave the controller empty if you do not need it.
 */
function ($scope,$http) {
    
    
    var ctrl = this;
    ctrl.userId= $scope.properties.userId;
    ctrl.taskId= $scope.properties.taskId;
    ctrl.statusCall='';
    
   // add a new variable in AngularJS scope. It'll be usable in the template directly with {{ backgroudColor }} 
     $scope.$watch('properties.taskId',function(){
        console.log("Widget-assignUserid at ["+$scope.properties.taskId+"] ["+$scope.properties.userId+"]");
        ctrl.taskId=$scope.properties.taskId;
        ctrl.userId=$scope.properties.userId;
        
        var data={'assigned_id': $scope.properties.userId };
   
        doAssignRequest('PUT', '../API/bpm/humanTask/' + $scope.properties.taskId, data);
    
        });
   
  
    /**
   * Execute a get/post request to an URL
   * It also bind custom data from success|error to a data
   * @return {void}
   */
  function doAssignRequest(method, url, params) {
    if (typeof (ctrl.taskId) === "undefined")
    {
        return;
    }   
    
    var req = {
      method: method,
      url: url,
      data: angular.copy(params)
    };
    var self=ctrl;
    $http(req)
      .success(function(data, status) {
          self.statusCall="Assigned";
      })
      .error(function(data, status) {
        self.statusCall = data?data:status;
      })
      .finally(function() {
      });
      
   
  };
  
},
      template: '<!-- The custom widget template is defined here\n   - You can use standard HTML tags and AngularJS built-in directives, scope and interpolation system\n   - Custom widget properties defined on the right can be used as variables in a templates with properties.newProperty\n   - Functions exposed in the controller can be used with ctrl.newFunction()\n   - You can use the \'environment\' property injected in the scope when inside the Editor whiteboard. It allows to define a mockup\n     of the Custom Widget to be displayed in the whiteboard only. By default the widget is represented by an auto-generated icon\n     and its name (See the <span> below).\n-->\n \n\n<div class="hidden">\n    {{ctrl.statusCall}}\n   \n</div>'
    };
  });
